// Point&Figure extensions library
// Copyright (c) 2012-2014 Roman Rich
#include            "main.mq4"

//     :
//  double-...
// ...   ,... 
// ... true -  , false -  ,...
// ...       
double MathNorm(double value,double var_box,bool vect,uint prec)
{
	if(vect==true)
		return(NormalizeDouble(MathCeil(value/var_box)*var_box,prec));
	else
		return(NormalizeDouble(MathFloor(value/var_box)*var_box,prec));
};

// ,     
bool IsNewBars()
{
	CopyTime(symbol,time_frame,0,1,cur_bar_time_dig);
	TimeToStruct(cur_bar_time_dig[0],cur_bar_time_struct);
	if(time_frame==PERIOD_M1||
	   time_frame==PERIOD_M2||
	   time_frame==PERIOD_M3||
	   time_frame==PERIOD_M4||
	   time_frame==PERIOD_M5||
	   time_frame==PERIOD_M6||
	   time_frame==PERIOD_M10||
	   time_frame==PERIOD_M12||
	   time_frame==PERIOD_M15||
	   time_frame==PERIOD_M20||
	   time_frame==PERIOD_M30)
		if(cur_bar_time_struct.min!=prev_bar_time_struct.min)
		{
			prev_bar_time_dig[0]=cur_bar_time_dig[0];
			TimeToStruct(prev_bar_time_dig[0],prev_bar_time_struct);
			return(true);
		};
	if(time_frame==PERIOD_H1||
	   time_frame==PERIOD_H2||
	   time_frame==PERIOD_H3||
	   time_frame==PERIOD_H4||
	   time_frame==PERIOD_H6||
	   time_frame==PERIOD_H8||
	   time_frame==PERIOD_H12)
		if(cur_bar_time_struct.hour!=prev_bar_time_struct.hour)
		{
			prev_bar_time_dig[0]=cur_bar_time_dig[0];
			TimeToStruct(prev_bar_time_dig[0],prev_bar_time_struct);
			return(true);
		};
	if(time_frame==PERIOD_D1||
	   time_frame==PERIOD_W1)
		if(cur_bar_time_struct.day!=prev_bar_time_struct.day)
		{
			prev_bar_time_dig[0]=cur_bar_time_dig[0];
			TimeToStruct(prev_bar_time_dig[0],prev_bar_time_struct);
			return(true);
		};
	if(time_frame==PERIOD_MN1)
		if(cur_bar_time_struct.mon!=prev_bar_time_struct.mon)
		{
			prev_bar_time_dig[0]=cur_bar_time_dig[0];
			TimeToStruct(prev_bar_time_dig[0],prev_bar_time_struct);
			return(true);
		};
	return(false);
};