// Expert main module
// Copyright (c) 2012-2014 Roman Rich
//       
#property           strict
#property           version             "1.01"
#property           link                "https://www.facebook.com/roman.i.rich"
#property           copyright           "Copyright (c) 2012-2014 Roman Rich"
#property           description         "Buy -             "
#property           description         "Sell -             "
#property           description         "SL - "
#property           description         "TP - "
#property           description         "Trail -     "

//#include            "symbol_list.mqh"
#include            "working_vars.mqh"
#include            "extensions_lib.mqh"
#include            "recalc_indicators_lib.mqh"
#include            "order_place.mqh"
#include            "on_init_lib.mqh"
#include            "on_tick_lib.mqh"
#include            "on_timer_lib.mqh"
#include            "on_test_lib.mqh"

int IsTradeCondition()
{
//  ?
	if(order_col_number!=column_count)
	{
		if(OrdersTotal()>0)
		{
			for(int loc_count_1=0;loc_count_1<OrdersTotal();loc_count_1++)
			{
				bool select_result=OrderSelect(loc_count_1,SELECT_BY_POS,MODE_TRADES);
//  -   ?
				if((OrderSymbol()==symbol)&&(OrderMagicNumber()==magic)&&((OrderType()==OP_BUYSTOP)||(OrderType()==OP_SELLSTOP)))
				{
//  !
					ticket=OrderTicket();
					bool delete_result=OrderDelete(ticket,clrNONE);
				};
			};
			order_col_number=column_count;
		};
	};
//  -   ?
	if(OrdersTotal()>0)
	{
		for(int loc_count_1=0;loc_count_1<OrdersTotal();loc_count_1++)
		{
			bool select_result=OrderSelect(loc_count_1,SELECT_BY_POS,MODE_TRADES);
			if(OrderSymbol()==symbol)
			{
				ticket=OrderTicket();
				break;
			}
			else
			{
				ticket=0;
			};
		};
	}
	else
	{
		ticket=0;
	};
	if((pnf[column_count-1].column_type=='O')&&((pnf[column_count-1].min_column_price>pnf[column_count-3].min_column_price)&&(pnf[column_count-2].max_column_price>pnf[column_count-4].max_column_price)))
	{
//   BUY , ,      BUY     ?
		trade_request_price=NormalizeDouble(MathPow(10,pnf[column_count-1].min_column_price+reverse*double_box),digit_2_orders);
		trade_request_sl=NormalizeDouble(MathPow(10,pnf[column_count-1].min_column_price),digit_2_orders);
		trade_request_tp=NULL;
		trade_request_type=OP_BUYSTOP;
		if(MathAbs(trade_request_price-MarketInfo(symbol,MODE_BID))*MathPow(10.0,MarketInfo(symbol,MODE_DIGITS))<MarketInfo(symbol,MODE_STOPLEVEL)*2) return(0);
		if(ticket==0)
		{
			PlaceOrder();
			order_col_number=column_count;
		}
		else
		{
			if((OrderCloseTime()==0)&&((OrderType()==OP_SELLSTOP)||((OrderType()==OP_BUYSTOP)&&(OrderOpenPrice()!=trade_request_price))))
			{
				bool delete_result=OrderDelete(ticket,clrNONE);
				PlaceOrder();
				order_col_number=column_count;
			};
		};
		return(0);
	}
	else
	if((pnf[column_count-1].column_type=='X')&&((pnf[column_count-1].max_column_price<pnf[column_count-3].max_column_price)&&(pnf[column_count-2].min_column_price<pnf[column_count-4].min_column_price)))
	{
//   SELL , ,      SELL     ?
		trade_request_price=NormalizeDouble(MathPow(10,pnf[column_count-1].max_column_price-reverse*double_box),digit_2_orders);
		trade_request_sl=NormalizeDouble(MathPow(10,pnf[column_count-1].max_column_price),digit_2_orders);
		trade_request_tp=NULL;
		trade_request_type=OP_SELLSTOP;
		if(MathAbs(trade_request_price-MarketInfo(symbol,MODE_ASK))*MathPow(10.0,MarketInfo(symbol,MODE_DIGITS))<MarketInfo(symbol,MODE_STOPLEVEL)*2) return(0);
		if(ticket==0)
		{
			PlaceOrder();
			order_col_number=column_count;
		}
		else
		{
			if((OrderCloseTime()==0)&&((OrderType()==OP_BUYSTOP)||((OrderType()==OP_SELLSTOP)&&(OrderOpenPrice()!=trade_request_price))))
			{
				bool delete_result=OrderDelete(ticket,clrNONE);
				PlaceOrder();
				order_col_number=column_count;
			};
		};
		return(0);
	}
	else
		return(0);
};

int IsTrailCondition()
{
	bool select_result=OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
	if(OrderType()==OP_BUY)
	{
		trade_request_sl=NormalizeDouble(MathPow(10,pnf[column_count-1].max_column_price-reverse*double_box),digit_2_orders);
		if(MathAbs(trade_request_sl-MarketInfo(symbol,MODE_BID))*MathPow(10.0,MarketInfo(symbol,MODE_DIGITS))<MarketInfo(symbol,MODE_STOPLEVEL)) return(0);
	}
	else
	{
		trade_request_sl=NormalizeDouble(MathPow(10,pnf[column_count-1].min_column_price+reverse*double_box),digit_2_orders);
		if(MathAbs(trade_request_sl-MarketInfo(symbol,MODE_ASK))*MathPow(10.0,MarketInfo(symbol,MODE_DIGITS))<MarketInfo(symbol,MODE_STOPLEVEL)) return(0);
	};
	if(OrderStopLoss()!=trade_request_sl) PlaceTrailOrder();
	return(0);
};