// Trade function library
// Copyright (c) 2012-2014 Roman Rich
#include            "main.mq4"

int PlaceOrder()
{
//    
	double digits_2_lot=(double)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
	double trade_risk=AccountInfoDouble(ACCOUNT_EQUITY)*opt_f;
	double one_tick_loss_min_lot=SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_VALUE)*SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
//    
	if(is_const_lot==true)
	{
		order_vol=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN);
	}
	else
	{
		order_vol=trade_risk/(MathAbs(trade_request_price-trade_request_sl)*MathPow(10,digits_2_lot)*one_tick_loss_min_lot)*SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
		order_vol=MathMax(order_vol,SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN));
		if(SymbolInfoDouble(symbol,SYMBOL_VOLUME_LIMIT)!=0.0) order_vol=MathMin(order_vol,SymbolInfoDouble(symbol,SYMBOL_VOLUME_LIMIT));
		order_vol=NormalizeDouble(order_vol,(int)MathAbs(MathLog10(SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP))));
	}
//  
	//Print("trade_request_type - ",trade_request_type,", trade_request_volume - ",order_vol,", trade_request_price - ",trade_request_price,", trade_request_slippage - ",trade_request_slippage,", trade_request_sl - ",trade_request_sl,", trade_request_tp - ",trade_request_tp);
	while(order_vol>0)
	{
		trade_request_volume=MathMin(order_vol,SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX));
		ticket=OrderSend(symbol,trade_request_type,trade_request_volume,trade_request_price,trade_request_slippage,trade_request_sl,trade_request_tp,NULL,magic,0,clrNONE);
		order_vol=order_vol-SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX);
	};
	return(0);
};

int PlaceTrailOrder()
{
	bool modify_result=OrderModify(ticket,OrderOpenPrice(),trade_request_sl,OrderTakeProfit(),0,clrNONE);
	return(0);
};